<?php

namespace QUI\NodeDev;

use QUI;
use QUI\Exception;
use QUI\Smarty\Collector;

use function json_encode;

class Events
{
    /**
     * Beginnt das Sammeln von Template-Daten und fügt die importmap hinzu.
     *
     * @throws Exception
     */
    public static function onTemplateBegin(
        Collector $Collection,
        QUI\Template $Template
    ): void {
        $nodePath = Console::getNodeProjectPath();
        $generator = new ImportMapGenerator($nodePath);
        $importMap = $generator->generateImportMap();

        $importMapString = PHP_EOL;
        $importMapString .= '<script type="importmap">' . PHP_EOL;
        $importMapString .= json_encode($importMap, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES) . PHP_EOL;
        $importMapString .= '</script>';
        $importMapString .= '<script>';
        $importMapString .= "window.process = { env: { NODE_ENV: 'production' } };";
        $importMapString .= '</script>';

        $Collection->append($importMapString);
    }
}
